p_Room

	//==========================================================================
	parent_type	= /p_PeopleHandler

	//==========================================================================
	p_Reconnected(Person)
		if ( src.p_IsListed(Person) )	src.p_AddInterfaceRoom(Person)
		return ..(Person)

	//==========================================================================
	proc
		//----------------------------------------------------------------------
		//	This can be defined to add a custom interface.
		//	Called automatically by p_Entered().
		//	Returns TRUE if Person can use an interface.
		p_AddInterfaceRoom(Person)
			var/mob/M	= Person
			return (istype(M) && M.client)

		//----------------------------------------------------------------------
		//	Returns whether or not Person can enter the room.
		//	TRUE by default.
		p_Enter(Person)
			return TRUE

		//----------------------------------------------------------------------
		//	Person has entered the room as a spectator.
		p_Entered(Person,p_Room/OldRoom,AutomatedCall=FALSE)
			if ( istype(OldRoom) )	OldRoom.p_Exited(Person,TRUE)
			src.p_AddInterfaceRoom(Person)
			src.p_AddSpectator(Person,AutomatedCall)

		//----------------------------------------------------------------------
		//	Returns whether or not Person can exit the room.
		//	TRUE by default.
		p_Exit(Person)
			return TRUE

		//----------------------------------------------------------------------
		//	Removes Person from the room's p_people and removes the interface.
		p_Exited(Person,AutomatedCall=FALSE)
			src.p_RemoveInterfaceRoom(Person)
			src.p_RemoveSpectator(Person,AutomatedCall)
			src.p_RemoveWaiter(Person,AutomatedCall)
			src.p_RemovePlayer(Person,AutomatedCall)

		//----------------------------------------------------------------------
		//	This can be defined to remove a custom interface.
		//	Called automatically.  Returns TRUE if Person can use an interface.
		p_RemoveInterfaceRoom(Person)
			var/mob/M	= Person
			return (istype(M) && M.client)
